package me.wazup.hideandseek.managers;

import org.bukkit.event.EventHandler;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.event.player.PlayerJoinEvent;
import java.util.Iterator;
import org.bukkit.entity.Player;
import java.io.IOException;
import me.wazup.hideandseek.utils.Utils;
import java.io.Reader;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import org.bukkit.plugin.Plugin;
import me.wazup.hideandseek.HideAndSeek;
import org.bukkit.Bukkit;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import org.bukkit.event.Listener;

public class NotificationsManager implements Listener
{
    private final String pluginName = "HideAndSeek";
    private final String permission = "hideandseek.admin";
    private final String url = "https://musing-jennings-3f352c.netlify.app/";
    private final long fetchInterval = 21600000L;
    private final long notificationInterval = 21600000L;
    private boolean notificationAvailable;
    private final List<String> messages;
    private long lastCheck;
    private final HashMap<String, Long> notifiedPlayers;
    
    public NotificationsManager() {
        this.messages = new ArrayList<String>();
        this.lastCheck = 0L;
        this.notifiedPlayers = new HashMap<String, Long>();
        Bukkit.getPluginManager().registerEvents((Listener)this, (Plugin)HideAndSeek.getInstance());
    }
    
    public void fetch() {
        this.lastCheck = System.currentTimeMillis();
        try {
            final BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(new URL("https://musing-jennings-3f352c.netlify.app/").openStream()));
            this.notificationAvailable = false;
            final String lowerCase = bufferedReader.readLine().replace("enabled-plugins: ", "").toLowerCase();
            if (lowerCase.contains("all_plugins") || lowerCase.contains("HideAndSeek".toLowerCase())) {
                this.notificationAvailable = true;
            }
            if (!this.notificationAvailable) {
                return;
            }
            this.messages.clear();
            String line;
            while ((line = bufferedReader.readLine()) != null) {
                this.messages.add(Utils.colorize(line).replace("%permission%", "hideandseek.admin").replace("%plugin%", "HideAndSeek"));
            }
        }
        catch (final IOException ex) {
            this.notificationAvailable = false;
        }
    }
    
    public void notifyPlayer(final Player player) {
        if (this.notificationAvailable && System.currentTimeMillis() - this.notifiedPlayers.getOrDefault(player.getName(), 0L) >= 21600000L) {
            this.notifiedPlayers.put(player.getName(), System.currentTimeMillis());
            final Iterator<String> iterator = this.messages.iterator();
            while (iterator.hasNext()) {
                player.sendMessage((String)iterator.next());
            }
        }
    }
    
    @EventHandler
    public void onPlayerJoinEvent(final PlayerJoinEvent playerJoinEvent) {
        final Player player = playerJoinEvent.getPlayer();
        if (player.hasPermission("hideandseek.admin")) {
            if (this.lastCheck == 0L || System.currentTimeMillis() - this.lastCheck >= 21600000L) {
                new BukkitRunnable() {
                    public void run() {
                        NotificationsManager.this.fetch();
                        NotificationsManager.this.notifyPlayer(player);
                    }
                }.runTaskAsynchronously((Plugin)HideAndSeek.getInstance());
            }
            else {
                this.notifyPlayer(player);
            }
        }
    }
}
